#[doc = "Register `D16` reader"]
pub struct R(crate::R<D16_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<D16_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<D16_SPEC>> for R {
    fn from(reader: crate::R<D16_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `D16` writer"]
pub struct W(crate::W<D16_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<D16_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<D16_SPEC>> for W {
    fn from(writer: crate::W<D16_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `D1` reader - Data 1"]
pub struct D1_R(crate::FieldReader<u8, u8>);
impl D1_R {
    pub(crate) fn new(bits: u8) -> Self {
        D1_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for D1_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `D1` writer - Data 1"]
pub struct D1_W<'a> {
    w: &'a mut W,
}
impl<'a> D1_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u8 & 0xff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Data 1"]
    #[inline(always)]
    pub fn d1(&self) -> D1_R {
        D1_R::new((self.bits & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Data 1"]
    #[inline(always)]
    pub fn d1(&mut self) -> D1_W {
        D1_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Data 1\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [d16](index.html) module"]
pub struct D16_SPEC;
impl crate::RegisterSpec for D16_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [d16::R](R) reader structure"]
impl crate::Readable for D16_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [d16::W](W) writer structure"]
impl crate::Writable for D16_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets D16 to value 0"]
impl crate::Resettable for D16_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
